{% extends 'core/base_bs.html' %}
{% load humanize %}
{% load i18n static %}

{% block meta %}
    {{ block.super }}
    <meta name="copyright" content="New Cameroon">
    <meta name="abstract" content="{% trans "Find the nearest ELECAM registration spot." %}"/>
    <meta name="description" content="{% trans "Get an alert when an ELECAM registration spot is available near you." %}"/>

    <meta property="og:type" content="website"/>
    <meta property="og:site_name" content="New Cameroon">
    <meta property="og:title" content="{% trans "Find the nearest ELECAM registration spot." %}"/>
    <meta property="og:description" content="{% trans "Get an alert when an ELECAM registration spot is available near you." %}"/>
    <meta property="og:url" content="{% url 'home' %}"/>
    <meta property="og:image" content="{% static 'newcameroon/img/happy-person.jpg' %}"/>

    {% include 'core/snippets/color_and_icons.html' %}
{% endblock %}

{% block page_title %}
    <title>{% trans "Add an ELECAM registration spot." %}</title>
{% endblock %}

{% block head_style %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static 'newcameroon/css/registration.css' %}?v=25.2.9">
{% endblock %}

{% block content %}
    <div class="text-center">
        <img src="{% static 'newcameroon/img/add-spot.jpg' %}" width="150" alt="add spot" />
    </div>
    <section>
        <div class="container">
        {% if request.GET.citizen_id %}
            <h2 class="page-title text-center" style="float: none; margin-bottom: 20px">
                {% trans "Got it! We are looking a registration spot for you." %}
            </h2>
            <div class="text-center">
                <p style="font-size: 45px">😊😊😊</p>
                <p>{% blocktrans %}
                    We would like to inform you by SMS when we have an information.
                    SMS is not free, you may want to support us for that and for this work,
                    by making a donation. It will be highly appreciated! 🙏🙏🙏
                {% endblocktrans %}</p>
                <div class="donations">
                    <h5 style="font-size: 1.1em; font-weight: 700; margin-top: 30px">{% trans "Donate using Orange Money or MTN MoMo" %}</h5>
                    <ul style="margin: 0; padding: 0">
                    {% for suggestion in donate_suggestions %}
                        <li class="payment-start" data-amount="{{ suggestion.amount }}">
                            <div>
                                <div style="font-size: 30px">{{ suggestion.emote }}{% if forloop.counter == 1 %}&#127996;{% endif %}</div>
                                <div>
                                    <span class="text-muted currency">XAF</span>
                                    <strong class="amount">{{ suggestion.amount|intcomma }}</strong>
                                </div>
                            </div>
                        </li>
                    {% endfor %}
                    </ul>
                    <div class="clearfix"></div>
                </div>
                <p class="text-center" style="margin-top: 45px">
                    <a href="{% url 'home' %}">
                        {% trans "Return home" %}
                    </a>
                </p>
            </div>
        {% else %}
            <h1 class="page-title text-center" style="float: none">
                {% trans "Get an alert when an ELECAM registration spot is available near you." %}
            </h1>
            <form method="post" id="remind-me"
                  class="col-sm-10 col-md-8 col-sm-offset-1 col-md-offset-2">
                {% csrf_token %}
                <div class="form-group">
                    <label for="city">{% trans "City" %}</label>
                    <input type="hidden" id="city-id" name="city"
                           value="{% if hood %}{{ hood.city.id }}{% else %}{{ request.GET.city_id }}{% endif %}" />
                    <input type="text" id="city" class="form-control"
                           value="{% if hood %}{{ hood.city.name }}{% endif %}" autofocus />
                    <div class="results cities has-shade" style="display: none; max-height: 300px; overflow: auto"
                         data-min-search-chars="3">
                        {% include 'core/snippets/spinner.html' %}
                        <ul class="object-list" style="padding-left: 0">
                            <li class="city ik-li tpl" style="display: none">
                                <div class="name"></div>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                </div>
                <div class="form-group hood"{% if not hood_list %} style="display: none"{% endif %}>
                    <label for="hood">{% trans "Hood" %}</label>
                    <input type="hidden" id="hood-id" name="hood" value="{{ request.GET.hood_id }}" />
                    <input type="text" id="hood" class="form-control" value="{{ hood.name }}" disabled />
                    <div class="results hoods has-shade" style="display: none; max-height: 300px; overflow: auto"
                         data-min-search-chars="3">
                        {% include 'core/snippets/spinner.html' %}
                        <ul class="object-list" style="padding-left: 0">
                            <li class="hood ik-li tpl" style="display: none">
                                <div class="name"></div>
                            </li>
                            <li class="ik-li" id="__other__">
                                <div class="name">{% trans "Add a new hood" %}</div>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                </div>
                <div class="form-group new-hood"{% if hood_list %} style="display: none"{% endif %}>
                    <label for="new-hood">{% trans "Hood name" %}</label>
                    <input type="text" id="new-hood" name="new_hood" class="form-control" maxlength="100" />
                </div>
                <div class="form-group email">
                    <label for="email">{% trans "Your email" %}</label>
                    <input id="email" type="email" name="email" class="form-control" />
                </div>
                <div class="form-group phone">
                    <label for="phone">{% trans "Your phone" %}</label>
                    <input id="phone" type="text" name="phone" class="form-control" />
                </div>
                <div class="form-group expected-on">
                    <label for="expected-on">{% trans "When do you plan to register?" %}</label>
                    <select id="expected-on" name="expected_on" class="form-control">
                        <option value="">-------</option>
                        <option value="this-week">{% trans "This week" %}</option>
                        <option value="next-week">{% trans "Next week" %}</option>
                        <option value="next-2-weeks">{% trans "Next 2 weeks" %}</option>
                        <option value="next-month">{% trans "Next month" %}</option>
                        <option value="next-2-months">{% trans "Next 2 months" %}</option>
                    </select>
                    <div style="margin-top: 10px">
                        <div class="text-muted this-week comment hidden">{% trans "🤔 Well, we will do even faster to find a spot for you." %}</div>
                        <div class="text-muted next-week comment hidden">{% trans "😊 OK, that gives us a few days to find the right spot for you." %}</div>
                        <div class="text-muted next-2-weeks comment hidden">{% trans "😎 Good... But please, keep the motivation in the meantime." %}</div>
                        <div class="text-muted next-month comment hidden">
                            <p style="font-size: 30px">😳😳😳</p>
                            <p>{% trans "Hmmmm... This looks rather far, we think you should do it faster." %}</p>
                        </div>
                        <div class="text-muted next-2-months comment hidden">
                            <p style="font-size: 30px">😱😱😱</p>
                            <p>{% trans "Noooo... Please don't be the last minute man. Do it earlier and avoid congestions." %}</p>
                        </div>
                    </div>
                </div>
                <div class="form-group" style="margin-top: 50px">
                    <button type="submit" style="min-width: 240px"
                            class="btn btn-md btn-deep-blue submit-spot">{% trans "Submit" %}</button>
                </div>
                {% if errors %}
                    <p class="error">{{ errors }}</p>
                {% endif %}
            </form>
        {% endif %}
        </div>
    </section>
    {% include 'billing/snippets/modal_payment_options.html' %}
{% endblock %}

{% block js %}
    {{ block.super }}
    <script>
        (() => {
            $('body').on('click', '.results.cities li.city', function() {
                let cityId = $(this).prop('id'),
                    cityName = $(this).find('.name').text();
                $('#city-id').val(cityId);
                $('#city').data('id', cityId).val(cityName);
                if (!cityId) {
                    $('#hood').prop('disabled', true).text("");
                    return
                }
                $('.form-group.city').removeClass('has-error');
                $('.form-group.new-hood, .form-group.date').hide();
                $('#category').val("");
                $.getJSON('/', {action: 'list_hoods', city_id: cityId}, function(data) {
                    if (data.length === 0) {
                        $('.form-group.hood').hide()
                        $('.form-group.new-hood').show()
                        $('#new-hood').focus()
                    } else {
                        $('.form-group.hood').show()
                        $('.form-group.new-hood').hide();
                        $('#hood').prop('disabled', false).val("").focus()
                    }
                })
            }).on('blur', '#city', function() {
                if ($('.city.ik-li:not(.tpl)').length > 0) $('.city.ik-li:first').click();
            }).on('click', '.results.hoods li', function() {
                let hoodId = $(this).prop('id'),
                    hoodName = $(this).find('.name').text();
                $('#hood-id').val(hoodId);
                $('#hood').val(hoodName);
                if (hoodId) $('.form-group.hood').removeClass('has-error');
                if (hoodId === '__other__') {
                    $('.form-group.new-hood').show();
                    $('#new-hood').val("").focus()
                } else {
                    $('#new-hood').val("")
                    $('.form-group.new-hood').hide();
                    $('#place').focus()
                }
            }).on('focus', '#hood', function() {
                let hoodId = $('#hood-id').val();
                if (hoodId === "__other__") {
                    $('#hood-id, #hood, #new-hood').val("")
                    $('.form-group.new-hood').hide();
                }
            }).on('blur', '#hood', function() {
                if ($('.hood.ik-li:not(.tpl)').length > 0) $('.hood.ik-li:first').click();
            }).on('change', '#expected-on', function() {
                let expectedOn = $(this).val();
                $(".form-group.expected-on .comment").addClass('hidden');
                $(`.form-group.expected-on .comment.${expectedOn}`).removeClass('hidden');
            })
            $('#remind-me').submit(function() {
                let city = $('#city-id').val(),
                    hood = $('#hood-id').val(),
                    newHood = $('#new-hood').val(),
                    expectedOn = $('#expected-on').val(),
                    email = $('#email').val(),
                    phone = $('#phone').val(),
                    error = false;
                $('.form-group').removeClass('has-error');
                if (!city) {
                    $('.form-group.city').addClass('has-error');
                    error = true
                }
                if (!hood || (hood === '__other__' && !newHood)) {
                    if (!hood) $('.form-group.hood').addClass('has-error');
                    if (hood === '__other__' && !newHood) $('.form-group.new-hood').addClass('has-error');
                    error = true
                }
                if (!(email || phone)) {
                    if (!email) $('.form-group.email').addClass('has-error');
                    if (!phone) $('.form-group.phone').addClass('has-error');
                    error = true
                }
                if (!expectedOn) {
                    $('.form-group.expected-on').addClass('has-error');
                    error = true
                }
                return !error;
            })
            $('#city').focusout(function () {
                $('.results.cities').fadeOut()
            });
            ikwen.setupSearch('#city', '.results.cities', [{
                endpoint: '/?action=list_cities',
                resultTplSelector: '.results.cities li.city',
                searchParam: 'name',
                minChars: 2,
                maxChars: function () {
                    // The max number of characters that will be taken into consideration
                    // in the string typed by user to do the search. Characters above that
                    // limit will be ignored.
                    return Math.max($('#city').val().length, 7);
                }
            }]);

            $('#hood').focusout(function () {
                $('.results.hoods').fadeOut()
            });
            ikwen.setupSearch('#hood', '.results.hoods', [{
                endpoint: function() {
                    return `/?action=list_hoods&city_id=${$('#city').data('id')}`
                },
                resultTplSelector: '.results.hoods li.hood',
                searchParam: 'name',
                minChars: 2,
                maxChars: function () {
                    // The max number of characters that will be taken into consideration
                    // in the string typed by user to do the search. Characters above that
                    // limit will be ignored.
                    return Math.max($('#hood').val().length, 7);
                }
            }]);
        })()
    </script>
{% endblock %}